/***************
adevs, a library supporting discrete event simulation
Copyright (C) 2001 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
#include <adevs/adevs.h>
using namespace adevs;

qode::qode (unsigned N) {

this->N = N;
q = new qintg [N];
sigma = INFINITY;

}

void qode::setParams(double D, double e) {

for (unsigned i = 0; i < N; i++)
	setParams(i,D,e);

}

void qode::init (const double* q0, const double* dq0) {

for (unsigned i = 0; i < N; i++)
	q[i].init(q0[i],dq0[i]);
compute_ta();

}

void qode::integ (double dt, const double* dq) {

for (unsigned i = 0; i < N; i++) 
	q[i].integ(dt,dq[i]);
compute_ta();

}

void qode::compute_ta() {

sigma = INFINITY;
for (unsigned i = 0; i < N; i++)
	if (sigma > q[i].ta()) sigma = q[i].ta();

}
