/***************
adevs, a library supporting discrete event simulation
Copyright (C) 1999, 2000, 2001 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
#include <adevs/adevs.h>
using namespace adevs;

// default implementations for basic object methods

// tests for pointer equavilence
bool object::operator==(const object &other) const {
	return this == &other;
}

bool object::operator!=(const object &other) const {
	return !(this->operator==(other));
}

unsigned int object::hashcode() const {
	return (unsigned int)this;
}

object* object::clone() const { 
	CloneException err(this);
	throw err;
}

object::~object() {}

// end of class object
