
/**
OS model (job source/load balancer) for the simulated multiprocessor.
Generates jobs and assigns them to the processors based
on the shortest queue load balancing policy.
*/

#ifndef _OS_
#define _OS_
#include "genr.h"
#include "transd.h"
#include "lb.h"

class OS: public adevs::staticDigraph {

public:		OS (int num_procs, adevs::stime_t obs_time,
			adevs::stime_t genr_period, adevs::stime_t job_size,
			int job_limit = INT_MAX);

/// New jobs leave on the out port 
		static const adevs::port_t out;
/// Completed jobs arrive on the in port 
		static const adevs::port_t in;

private:	
/// Job generator
		genr* g;
/// Collects statistics
		transd* t;
/// Load balancing policy
		lb* l;

};

#endif
