
/**
Processor's assign time to jobs in round robin fashion.
*/
#ifndef _PROC_
#define _PROC_
#include "types.h"

class proc: public adevs::atomic {

public:
/// Create a processor with the given ID and processing time slice
		proc (int pid, adevs::stime_t time_slice);

		void reset ();
		void delta_int ();
		void delta_ext ();
		void delta_conf ();
		void output_func ();
/// Get the processor's PID
		inline int get_pid () const { return pid; }
/// Lookahead function 
		adevs::stime_t lookahead () const;
		~proc ();

/// New jobs arrive on the in port
		static const adevs::port_t in;
/// Old jobs leave on the out port
		static const adevs::port_t out;

private:	
/// Processor ID
		int pid;
/// Run list
		std::list<job> runq;
/// Current job finished?
		bool done;
/// Currently executing job
		job j;
/// Time slice size
		adevs::stime_t time_slice;

};

#endif
