/***********
Copyright (C) 1999, 2000  James Nutaro

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
/**

Model of the ball.

*/
class ball: public adevs::atomic {

public:
	ball ();
// construct ball with initial velocity
	ball (const vector& v_init);
// construct ball with initial shape
	ball (const circle& geom_init);
// construct ball with shape and velocity
	ball (const circle& geom_init, const vector& v_init);

// set the bounding box for the ball's motion
	void setWorld (const rectangle& world_size);
	void setWorld (double x, double y, double width, double height);

	void reset ();
	void delta_int ();
	void delta_ext ();
	void delta_conf ();
	void output_func ();

	~ball ();

// input ports
	static const adevs::port_t collision;
	static const adevs::port_t stop;

// output ports
	static const adevs::port_t motion; 
	static const adevs::port_t destroyed;

private:
// constants
	static const double MOTION_RES;

// initial state
	vector v_init;
	circle geom_init;

// state
	vector v;
	vector dp;
	circle geom;
	circle geom_op;
	rectangle world_size;
	eStatus status;

	void checkStatus ();
};

