/***********
Copyright (C) 1999, 2000  James Nutaro

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
/**

Model of the paddle.

*/

class paddle: public adevs::atomic {

public:
// constructors
	paddle ();
// create a paddle with initial shape
	paddle (const rectangle& geom_init);
// create a paddle with the indicated velocity (assume v.y = 0 for now).
	paddle (const vector& v_paddle);
// create a paddle with the indicated shape and velocity.
	paddle (const rectangle& geom_init, const vector& v_paddle);

	void reset ();
	void delta_int ();
	void delta_ext ();
	void delta_conf ();
	void output_func ();

	~paddle ();

// input ports
	static const adevs::port_t collision;
	static const adevs::port_t vcontrol;
	static const adevs::port_t ball_motion;
	static const adevs::port_t stop;

// output ports
	static const adevs::port_t motion; 
	static const adevs::port_t ball_collision;

private:
// constants
	static const double MOTION_RES;
	static const vector V_ZERO;

// initial state
	rectangle geom_init;

// state
	vector v_paddle;
	adevs::indexed collisions;
	vector v;
	vector dp;
	rectangle geom;
	rectangle geom_op;

	void setupPorts ();
};

