/***********
Copyright (C) 1999, 2000  James Nutaro

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
#include <adevs/adevs.h>
#include <stdlib.h>
#include "point.h"
using namespace adevs;

point::point ():object () { x = y = 0; }

point::point (int x, int y):object () { 

this->x = x;
this->y = y;

}

point::point (const point& src):object (src) {

this->x = src.x;
this->y = src.y;

}

const point& point::operator= (const point& p) {

this->x = p.x;
this->y = p.y;
return *this;

}

bool point::operator== (const object& obj) const {

const point* p = dynamic_cast<const point*> (&obj);
if (p == NULL) return false;
return (p->x == x && p->y == y);

}

bool point::operator!= (const object& obj) const {

const point* p = dynamic_cast<const point*> (&obj);
if (p == NULL) return true;
return (p->x != x || p->y != y);

}

unsigned point::hashcode () const {

return ((unsigned)(x ^ y));

}

point::~point () { }
