/***********
Copyright (C) 1999, 2000  James Nutaro

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
/**
A 2D point.  Used to locate objects in the cellspace.
*/

class point: public adevs::object {

public:		int x, y; 

// a few constructors.
		point ();
		point (int x, int y);
		point (const point& src);
		virtual adevs::object* clone () const { 
			return new point (*this); 
			}
// Method for setting the x and y values of this point.
		inline void set (int x, int y) { this->x = x; this->y = y; } 

// Assignment operator.  Assigns p's x and y values to this point.
// Returns a reference to this point.
		const point& operator= (const point& p);
	
// Two points are considered equal if a.x = b.x and a.y = b.y
		bool operator== (const adevs::object& src) const;
		bool operator!= (const adevs::object& src) const;
		unsigned hashcode () const;
		~point ();

};
