#include <adevs/adevs.h>
#include <iostream>
#include <assert.h>
#include "genr.h"

/**

Undefined input port test.

**/

const port_t genr::out = 0;

genr::genr (stime_t period, int ticks):atomic ("genr") {

this->period = period;
this->tick_limit = ticks;
this->tick_count = 0;

addOutputPort (out);

}

void genr::reset () {

tick_count = 0;
hold (0.0);

}

void genr::delta_ext () { assert (false); }

void genr::delta_int () { 

std::cout << "tick_count = " << tick_count << " @ t = " << timeCurrent () << std::endl;

inputOnPort (0);

tick_count++;
if (tick_count < tick_limit) {
   hold (period);
   std::cout << "period = " << period << std::endl;
   std::cout << "tN = " << timeNext () << std::endl;
   std::cout << "tL = " << timeLast () << std::endl;
   } 
else
   passivate ();

} 

void genr::delta_conf () { assert (false); }

void genr::output_func () {

output (out, new intg ());

}

genr::~genr () { }

int main () {

genr* g = new genr (10.0, 10);
devssim sim (g);

try {
sim.reset ();
sim.run ();
}
catch (UndefinedException& err) {
   std::cout << "Caught UndefinedException" << std::endl;
   std::cout << err.getError () << std::endl;
   }

 

std::cout << "Test done!" << std::endl;

}
