#include <adevs/adevs.h>
#include <iostream>
#include "step_deepgenr.h"
#include "step_genr.h"
using namespace adevs;

const port_t deepgenr::out = 0;
const port_t deepgenr::in1 = 1;
const port_t deepgenr::in2 = 2;

deepgenr::deepgenr ():staticDigraph ("deepgenr") {

genr* g = new genr (1.0, 10); 

try {

add (g);
addOutputPort (out);
addInputPort (in1);
addInputPort (in2);

couple (g, g->out, this, this->out);
couple (this, this->in1, g, g->in1);
couple (this, this->in2, g, g->in2);

}

catch (DEVSException& err) {
   std::cout << err.getError () << std::endl;
   throw err;
   }
   
}

deepgenr::~deepgenr () { }

int main () {

deepgenr* dg = new deepgenr ();

devssim sim (dg);

sim.reset ();

indexed input;
for (int i = 1; i <= 2; i++) 
   input.add (new port_value (genr::in1, new intg (i)));
for (int i = 3; i <= 4; i++) 
   input.add (new port_value (genr::in2, new intg (i)));

sim.step (1.0);
sim.step (0.5, input);
sim.run ();

std::cout << "Test done!" << std::endl;

}
