#include <adevs/adevs.h>
#include "genr.h"
#include "counter.h"
#include "delay.h"
#include "gcd.h"
using namespace adevs;

const port_t gcd::in = 0;
const port_t gcd::out = 1;
const port_t gcd::start = 2;
const port_t gcd::stop = 3;
const port_t gcd::signal = 4;

gcd::gcd (const stime_t* pattern, unsigned length, stime_t dt,
			unsigned iterations, bool active):
staticDigraph () {

genr* g = new genr (pattern, length, iterations, active);
delay* d = new delay (dt);
counter* c = new counter ();

build (g, c, d);

}

gcd::gcd (stime_t period, stime_t dt, unsigned iterations, bool active):
staticDigraph () {

genr* g = new genr (period, iterations, active);
delay* d = new delay (dt);
counter* c = new counter ();

build (g, c, d);

}

void gcd::build (genr* g, counter* c, delay* d) {

add (g);
add (d);
add (c);

addInputPort (in);
addInputPort (start);
addInputPort (stop);
addOutputPort (out);
addOutputPort (signal);

couple (this, in, d, d->in);
couple (this, start, g, g->start);
couple (this, stop, g, g->stop);
couple (g, g->signal, this, signal);
couple (d, d->out, this, out);
couple (d, d->out, c, c->in);

}

gcd::~gcd () { }
